remove(list = ls())
library(stats)
getwd()

yt=function(x0,u0){
  y=x0
  y[u0<=x0]=1
  y[u0>x0]=0
  return(y)
}

Kh=function(h,t0){
  y=t0
  y[abs(t0/h)>=1]=0
  y[abs(t0/h)<1]=0.75*(1-(t0[abs(t0/h)<1]/h)^2)/h
  return(y)
}

s0=function(beta,k0,locf){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  return(sum(yt(x,x[k0])*exp(beta*locf[,2])*idcova*Kh(h, x[k0]-locf[,1])))
}

s1=function(beta,k0,locf){
    return(sum(yt(x,x[k0])*exp(beta*locf[,2])*locf[,2] *Kh(h, x[k0]-locf[,1])))
}

s2=function(beta,k0,locf){
    return(sum(yt(x,x[k0])*exp(beta*locf[,2])*(locf[,2]^2)*Kh(h, x[k0]-locf[,1])))
}

fcova=function(i){
   cova=rep(0,n)
   cova_t = rep(0, n)
   for(j in 1:n){
        sik=observe[(ord[j]+1):(ord[j]+num[j])]
	  covariatei = covariate[(ord[j]+1):(ord[j]+num[j])]
	  sik[sik > x[i]] = -Inf
        neart = which.max(sik)
	  if (sik[neart]!=-Inf&&(!is.na(covariatei[neart])))
	  	{
           cova[j]=covariatei[neart] 
           cova_t[j] = sik[neart]
         }
   }
return(cbind(cova_t, cova))
}

basic = read.csv("dataset_317_basic.csv", header = TRUE)
long = read.csv("longitudinal.csv", header = TRUE)
count = read.csv("count.csv", header = TRUE)
count_baseline = count[,-5]
long_baseline = long[long[,39]==0,c(1,21,29)]
basic.0 = basic[,c(1, 5, 6, 7, 8, 14)]
basic.1 = merge(basic.0, count_baseline, by = "projid")
dim(basic.1)
basic.1[1:5,]
basic.2 = merge(basic.1, long_baseline, by = "projid")
dim(basic.2)
basic.2[1:5,]
surv_time = rep(0,nrow(basic.2))
delta = rep(1, nrow(basic.2))
for ( i in 1:nrow(basic.2)){
	if (is.na(basic.2[i,2])){
		delta[i] = 0
		surv_time[i] = basic.2[i,9]
	}
	if (!is.na(basic.2[i,2])){
		surv_time[i] = basic.2[i,2] - basic.2[i,8] 
	}	
}

censoring = 1-mean(delta)
censoring
survival_pure = cbind(basic.2, delta, surv_time)
survival_pure[1:10,]
dim(survival_pure)
library(survival)
summary(coxph(Surv(survival_pure[,13], survival_pure[,12]) ~ survival_pure[,10])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,11]+survival_pure[,7] + survival_pure[,6]+survival_pure[,5] + survival_pure[,4]+survival_pure[,3])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] +survival_pure[,7] + survival_pure[,6]+survival_pure[,5] + survival_pure[,4]+survival_pure[,3])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,7] + survival_pure[,6]+survival_pure[,5] + survival_pure[,4])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,7] +survival_pure[,5] + survival_pure[,4])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,5] + survival_pure[,4])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,7] +survival_pure[,5])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,7] +survival_pure[,4])) 
                    
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,7])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,5])) 
summary(coxph(Surv(surv_time, delta) ~ survival_pure[,10] + survival_pure[,4])) 



summary(x)
 summary(observe)