remove(list = ls())
library(stats)
getwd()

yt=function(x0,u0){
  y=x0
  y[u0<=x0]=1
  y[u0>x0]=0
  return(y)
}

Kh=function(h,t0){
  y=t0
  y[abs(t0/h)>=1]=0
  y[abs(t0/h)<1]=0.75*(1-(t0[abs(t0/h)<1]/h)^2)/h
  return(y)
}

fcova=function(i){
   cova=matrix(0, nrow = n, ncol = k )
   cova_t = rep(0, n)
   for(j in 1:n){
   	  if (num[j]==1){
   	  	sik=observe[(ord[j]+1):(ord[j]+num[j])]
	  covariatei = covariate[(ord[j]+1):(ord[j]+num[j]), ]
	  sik[sik > x[i]] = -Inf
        neart = which.max(sik)
	  if (sik[neart]!=-Inf&&(sum(is.na(covariatei)) ==0))
	  	{
           cova[j,]=covariatei 
           cova_t[j] = sik[neart]
         }
   	  }
   	  else{    
	sik=observe[(ord[j]+1):(ord[j]+num[j])]
	  covariatei = covariate[(ord[j]+1):(ord[j]+num[j]), ]
	  sik[sik > x[i]] = -Inf
        neart = which.max(sik)
	  if (sik[neart]!=-Inf&&(sum(is.na(covariatei[neart, ])) ==0))
	  	{
           cova[j,]=covariatei[neart,] 
           cova_t[j] = sik[neart]
         }
         }
   }
return(cbind(cova_t, cova))
}

basic = read.csv("dataset_317_basic.csv", header = TRUE)
long = read.csv("longitudinal.csv", header = TRUE)
count = read.csv("count.csv", header = TRUE)
basic.0 = basic[,c(1, 5, 6, 7, 8, 14)]
basic.2 = merge(basic.0, count, by = "projid")
dim(basic.2)
basic.2[1:20,]
surv_time = rep(0,nrow(basic.2))
delta = rep(1, nrow(basic.2))
for ( i in 1:nrow(basic.2)){
	if (is.na(basic.2[i,2])){
		delta[i] = 0
		surv_time[i] = basic.2[i,9]
	}
	if (!is.na(basic.2[i,2])){
		surv_time[i] = basic.2[i,2] - basic.2[i,8] 
	}	
}

censoring = 1-mean(delta)
censoring
survival_pure = cbind(basic.2, delta, surv_time)
survival_pure[1:10,]
dim(survival_pure)
dim(long)
ep = long[,c(1, 9, 21, 29, 39)]
ep[1:10,]
quantile(ep[,5], 0.25)
n = nrow(survival_pure)
n
effn = sum(delta)
effn
h = 2*(quantile(ep[,5], 0.75) - quantile(ep[,5], 0.25))*effn^(-0.5)
h
num = survival_pure[,10]
ord = 1:n
	ord[1] = 0
	for (i in 2:n){
		ord[i] = sum(num[1:(i-1)])
	}
	observe = ep[,5]
	#covariate = cbind(ep[,3], ep[,4], ep[,2], rep(survival_pure[,3], survival_pure[,10]), rep(survival_pure[,4], survival_pure[,10]),rep(survival_pure[,5], survival_pure[,10]),rep(survival_pure[,6], survival_pure[,10]))
	covariate = cbind(ep[,3], ep[,2])
k = ncol(covariate)
	x = survival_pure[,12]
	beta0 = rep(0.01, k)
	sign=0
 while(sign==0){
 L1=rep(0, k)
 L2=matrix(0, nrow = k, ncol = k)
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(sum(is.na(covariate[i,]))==0)){
     locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = sum(yt(x,x[i])*exp(locf[,-1]%*%beta0)*idcova     				*Kh(h, x[i]-locf[,1]))
  temp1 = apply(as.vector(yt(x,x[i])*exp(locf[,-1]%*%beta0))*locf[, -1]  				*Kh(h, x[i]-locf[,1]), 2, sum)
  temp2 = matrix(0, nrow = k, ncol = k)
  for (j in 1:n){
  temp2 = temp2 + as.vector(yt(x[j],x[i])*exp(locf[j,-1]%*%beta0))*locf[j, -1]%*%t(locf[j,-1])  *Kh(h, x[i]-locf[j,1])
         		}
         		
       if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, -1]-temp1/temp0)        * Kh(h, x[i] - locf[i, 1])
       L2=L2+(temp1%*%t(temp1)-temp0*temp2)/(temp0^2)* Kh(h, x[i] - locf[i, 1])
       		}
       }
   }
 }
 

 beta.hat = beta0 - solve(L2)%*%L1
    if (sum(abs(beta0-beta.hat)<10^-2)==k)
    sign=1
    beta0=beta.hat
 }
 beta0
 #beta0 =-0.055709 for bmi with weighted LOCF;
 
 L11=matrix(0, nrow = k, ncol = k)
 L2=matrix(0, nrow = k, ncol = k)
 for (i in 1:n){
   if ((num[i]>0) &&(delta[i]==1)&&(sum(is.na(covariate[i,]))==0)){
     locf2=fcova(i)
     if(locf2[i, 2]!=0){
  idcova2=rep(0,n)
  idcova2[locf2[,2]!=0]=1
  temp00 = sum(yt(x,x[i])*exp(locf2[,-1]%*%beta0)*idcova2     *Kh(h, x[i]-locf2[,1]))
  temp11 = apply(as.vector(yt(x,x[i])*exp(locf2[,-1]%*%beta0))*locf2[, -1]  *Kh(h, x[i]-locf2[,1]), 2, sum)
  temp22 = matrix(0, nrow = k, ncol = k)
  for (j in 1:n){
  temp22 = temp22 + as.vector(yt(x[j],x[i])*exp(locf2[j,-1]%*%beta0))*locf2[j, -1]%*%t(locf2[j,-1])  *Kh(h, x[i]-locf2[j,1])
         		}
       if (temp00==0) {next}
       else {
       L11=L11+((locf2[i, -1]-temp11/temp00) * Kh(h, x[i] - locf2[i, 1]))%*%t((locf2[i, -1]-temp11/temp00) * Kh(h, x[i] - locf2[i, 1]))
       L2=L2+(temp11%*%t(temp11)-temp00*temp22)/(temp00)^2 * Kh(h, x[i] - locf2[i, 1])
       		}
     }
   }
 }

  
 se2=(solve(L2)%*%L11%*%solve(L2))
 sqrt(diag(se2))
 beta0/sqrt(diag(se2))
 #next we look at LOCF 
 
 beta0 = rep(0.01, k)
	sign=0
 while(sign==0){
 L1=rep(0, k)
 L2=matrix(0, nrow = k, ncol = k)
 for (i in 1:n){
   if ((num[i]>0)&&(delta[i]==1)&&(sum(is.na(covariate[i,]))==0)){
     locf=fcova(i)
     if(locf[i,2]!=0){
  idcova=rep(0,n)
  idcova[locf[,2]!=0]=1
  temp0 = sum(yt(x,x[i])*exp(locf[,-1]%*%beta0)*idcova     				)
  temp1 = apply(as.vector(yt(x,x[i])*exp(locf[,-1]%*%beta0))*locf[, -1], 2, sum)
  temp2 = matrix(0, nrow = k, ncol = k)
  for (j in 1:n){
  temp2 = temp2 + as.vector(yt(x[j],x[i])*exp(locf[j,-1]%*%beta0))*locf[j, -1]%*%t(locf[j,-1]) 
         		}
         		
       if (temp0 ==0) {next}
       else {
       L1=L1+(locf[i, -1]-temp1/temp0)
       L2=L2+(temp1%*%t(temp1)-temp0*temp2)/(temp0^2)
       		}
       }
   }
 }
 

 beta.hat = beta0 - solve(L2)%*%L1
    if (sum(abs(beta0-beta.hat)<10^-2)==k)
    sign=1
    beta0=beta.hat
 }
 beta0
 
 
 L11=matrix(0, nrow = k, ncol = k)
 L2=matrix(0, nrow = k, ncol = k)
 for (i in 1:n){
   if ((num[i]>0) &&(delta[i]==1)&&(sum(is.na(covariate[i,]))==0)){
     locf2=fcova(i)
     if(locf2[i, 2]!=0){
  idcova2=rep(0,n)
  idcova2[locf2[,2]!=0]=1
  temp00 = sum(yt(x,x[i])*exp(locf2[,-1]%*%beta0)*idcova2     )
  temp11 = apply(as.vector(yt(x,x[i])*exp(locf2[,-1]%*%beta0))*locf2[, -1]  , 2, sum)
  temp22 = matrix(0, nrow = k, ncol = k)
  for (j in 1:n){
  temp22 = temp22 + as.vector(yt(x[j],x[i])*exp(locf2[j,-1]%*%beta0))*locf2[j, -1]%*%t(locf2[j,-1])  
         		}
       if (temp00==0) {next}
       else {
       L11=L11+((locf2[i, -1]-temp11/temp00))%*%t((locf2[i, -1]-temp11/temp00))
       L2=L2+(temp11%*%t(temp11)-temp00*temp22)/(temp00)^2        		
       }
     }
   }
 }

  
 se2=(solve(L2)%*%L11%*%solve(L2))
 sqrt(diag(se2))
 beta0/sqrt(diag(se2))
 

 
 summary(x)
 summary(observe)